# 中文分词
##Install Smart Chinese Analysis
```
curl -XPUT 'localhost:9200/_cluster/settings' -d '{
"transient" : {
"cluster.routing.allocation.enable" : "none"
}
}'

sudo -i service elasticsearch stop
bin/elasticsearch-plugin install  file:///home/centos/analysis-smartcn-5.4.1.zip 
sudo -i service elasticsearch start

curl -XPUT 'localhost:9200/_cluster/settings' -d '{
"transient" : {
"cluster.routing.allocation.enable" : "all"
}
}'

curl -XGET 'localhost:9200/_cat/health?pretty'
```

The plugin provides the `smartcn` analyzer and `smartcn_tokenizer` tokenizer, which are not configurable.

Note
The `smartcn_word` token filter and `smartcn_sentence` have been deprecated.

# Getting Started
```
curl -XPOST 'localhost:9200/_analyze?pretty' -H 'Content-Type: application/json' -d'
{
  "analyzer": "smartcn",
  "text":     "你好，请问Jkes搜索框架好用吗？"
}
'
```
result:
```
{
  "tokens" : [
    {
      "token" : "你好",
      "start_offset" : 0,
      "end_offset" : 2,
      "type" : "word",
      "position" : 0
    },
    {
      "token" : "请问",
      "start_offset" : 3,
      "end_offset" : 5,
      "type" : "word",
      "position" : 2
    },
    {
      "token" : "jke",
      "start_offset" : 5,
      "end_offset" : 9,
      "type" : "word",
      "position" : 3
    },
    {
      "token" : "搜索",
      "start_offset" : 9,
      "end_offset" : 11,
      "type" : "word",
      "position" : 4
    },
    {
      "token" : "框架",
      "start_offset" : 11,
      "end_offset" : 13,
      "type" : "word",
      "position" : 5
    },
    {
      "token" : "好",
      "start_offset" : 13,
      "end_offset" : 14,
      "type" : "word",
      "position" : 6
    },
    {
      "token" : "用",
      "start_offset" : 14,
      "end_offset" : 15,
      "type" : "word",
      "position" : 7
    },
    {
      "token" : "吗",
      "start_offset" : 15,
      "end_offset" : 16,
      "type" : "word",
      "position" : 8
    }
  ]
}

```
```
curl -XPOST 'localhost:9200/_analyze?pretty' -H 'Content-Type: application/json' -d'
{
  "tokenizer": "smartcn_tokenizer",
  "filter":  [ "lowercase", "asciifolding" ],
  "text":      "热爱大数据、Machine Learning、Deep Learning！"
}
'
```

```
curl -XPUT 'localhost:9200/my_index?pretty' -H 'Content-Type: application/json' -d'
{
  "settings": {
    "analysis": {
      "analyzer": {
        "std_folded": { 
          "type": "custom",
          "tokenizer": "smartcn_tokenizer",
          "filter": [
            "lowercase",
            "asciifolding"
          ]
        }
      }
    }
  },
  "mappings": {
    "my_type": {
      "properties": {
        "my_text": {
          "type": "text",
          "analyzer": "std_folded" 
        }
      }
    }
  }
}
'
curl -XGET 'localhost:9200/my_index/_analyze?pretty' -H 'Content-Type: application/json' -d'
{
  "analyzer": "std_folded", 
  "text":     "热爱大数据、Machine Learning、Deep Learning！"
}
'
curl -XGET 'localhost:9200/my_index/_analyze?pretty' -H 'Content-Type: application/json' -d'
{
  "field": "my_text", 
  "text":  "热爱运动，love movies、travel"
}
'
```

